local map = {
{1,1,1,1,1,1,1,1,1,1,1,1,1,1},
{1,0,0,0,0,0,0,0,0,0,0,0,0,1},
{1,0,1,0,1,0,1,0,0,0,1,1,0,1},
{1,0,0,0,0,0,0,0,0,0,1,1,0,1},
{1,1,0,1,0,1,0,1,0,0,0,0,0,1},
{1,0,0,0,0,0,0,0,0,0,0,0,0,1},
{1,0,0,0,0,0,0,0,0,0,0,0,0,1},
{1,0,0,0,0,0,0,0,1,1,0,0,0,1},
{1,0,0,0,0,0,0,0,1,1,0,0,0,1},
{1,0,1,0,0,0,0,0,0,0,0,0,0,1},
{1,0,0,0,0,0,0,0,0,0,0,0,0,1},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1},
}

local whd = 320
local centerh = 100
local center = whd/2
local camdist = center/math.tan(math.rad(30))
local column = 60/whd


local pla = {
	atype = "pla",
	grid_x = 2*32+16,
	grid_y = 2*32+16,
	act_x = 2*32+16,
	act_y = 2*32+16,
	speed = 2,
	r=0,
	ismoving = {x=false,y=false,overal=false,overalstate=true},
	g_r = 0,
	dir = "r",
	ll=false,
	rr=false,
	uu=false,
	dd=false,
	sl=false,
	sr=false
}

local dynamicmap = {}
local bots = {}
for i=1,10 do
	bots[i] = {
		atype = "bot",
		subtype = "",
		alive = true,
		i = 1,
		spawn_x= 5*32+16,
		spawn_y= 5*32+16,
	    	grid_x = 5*32+16,
       		grid_y = 5*32+16,
       		act_x = 5*32+16,
       		act_y = 5*32+16,
		ismoving = {x=false,y=false,overal=false,overalstate=true},
		draw_x = 0,
       		draw_y = 0,
       		speed = 1,
	   	r = 0,
		g_r = 0,
		dir = "r",
		visible = true,
		comp = "calc",
		dynamic = 0
        }
end

--[[local floorent = {}
local floorpoint = {}
for y=1,#map do
	for x=1,#map[1] do
		if map[y][x] == 0 then
			floorent[#floorent+1] = {
				atype = "floor",
				act_x = x*32+16,
       				act_y = y*32+16,
				r=0,
			}
		end
	end
end]]

local dirinfo = {
[270] = {d="u",l=180,r=360,is={true,false,false,false}},
[0] = {d="r",l=270,r=90,is={false,false,false,true}},
[360] = {d="r",l=270,r=90,is={false,false,false,true}},
[180] = {d="l",l=90,r=270,is={false,false,true,false}},
[90] = {d="d",l=0,r=180,is={false,true,false,false}},
}

love.graphics.setDefaultImageFilter( "nearest","nearest" )
local wallimg = love.graphics.newImage("bri1.png")
local slicewallimg = {}
for i = 1, 64 do
	slicewallimg[i] = love.graphics.newQuad(i-1, 0, 1, 64, 64, 64 )
end

local dim = math.max(#map[1]*32,#map*32)
local fullfloor = love.graphics.newCanvas(dim,dim)
fullfloor:renderTo(function()
	for y=1,#map do
		for x=1,#map[1] do
			if map[y][x] == 0 then
				love.graphics.draw(wallimg,(x-1)*32,(y-1)*32,0,0.5,0.5)
			end
		end
	end
end)
local range2 = 14*32*1.29--dim*1.29--math.floor(distance(0,0,dim,dim))
local fullfloortodraw = love.graphics.newCanvas(rande2, range2)
fullfloortodrawQuad = {}
for i = 0, fullfloortodraw:getHeight()-1 do
	fullfloortodrawQuad[i] = love.graphics.newQuad(0, fullfloortodraw:getHeight()-i, fullfloortodraw:getWidth(), 1, fullfloortodraw:getWidth(), fullfloortodraw:getHeight())
end
fullfloortodraw:setFilter("nearest","nearest")

function maketransparent(file)
	local ratimgdata = love.image.newImageData(file)
	for i=0,63 do
		for j=0,63 do
			local r,g,b,a = ratimgdata:getPixel(i,j)
			if r == 255 and g == 255 and b == 255 and a == 255 then
				ratimgdata:setPixel(i,j,255,255,255,0)
			end
		end
	end
	return love.graphics.newImage(ratimgdata)
end
local ratimgT = {}
ratimgT[0] = maketransparent("rat0.png")
ratimgT[1] = maketransparent("rat1.png")
ratimgT[2] = maketransparent("rat2.png")
ratimgT[3] = maketransparent("rat3.png")
ratimgT[4] = ratimgT[0]
--f01img = maketransparent("f01.png")
local ratimg = ratimgT[0]
local mapdraw = love.graphics.newCanvas(320,200)
mapdraw:renderTo( function()
	for y=1,#map do
		for x=1,#map[1] do
			if map[y][x] == 1 then
				love.graphics.rectangle("fill",32+x*8,32+y*8,8,8)
			end
		end
	end
end )
local floordraw = love.graphics.newCanvas(320,200)
floordraw:renderTo( function()
	for i =0 ,centerh do
		love.graphics.setColor(150-i/100*150,80-i/100*80,80-i/100*80)
		love.graphics.line(0,i,whd,i)
	end
	for i =centerh ,2*centerh do
		love.graphics.setColor((i-centerh)/100*150,(i-centerh)/100*80,(i-centerh)/100*80)
		love.graphics.line(0,i,whd,i)
	end
	
end )

function setisplayermowing(elem,state,dir)
    if elem.ismoving then
	elem.ismoving[dir] = state
	elem.ismoving.overal = (elem.ismoving.x  or elem.ismoving.y)
   end
end

function rotateElement(p,dt)
	local g_r = p.g_r
	if p.atype == "bot" then
		g_r = p.g_r*90
	end
	if p.dir == "l" then
		p.r=p.r-dt*3*32
		if p.r <= 0 then
			g_r = 360
		end
		if p.r <= g_r then
			p.r = g_r
		end
	else
		p.r=p.r+dt*3*32
		if p.r >= 360 then
			g_r = 0
		end
		if p.r >= g_r then
			p.r = g_r
		end
	end
	if p.atype == "bot" then
		p.g_r = g_r/90
	else
		p.g_r = g_r
	end
end

function moveElement(elem,dt,dir) --smoudh moving
   if not dir then
	moveElement(elem,dt,"x")
	moveElement(elem,dt,"y")
   else
  	 if elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt) and elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt) then
 	     elem["act_"..dir] = elem["grid_"..dir]
	     setisplayermowing(elem,false,dir)
 	  elseif not (elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] - 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  elseif not (elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] + 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  end
   end
end

function moveGrid(elem,dir1,dir2,dir3,dir4) -- actual position change
	if elem.act_y == elem.grid_y and elem.act_x == elem.grid_x  then
        	elem["grid_"..dir1] = elem["grid_"..dir1] + dir2
		--elem.direction = elem.g_r
		
		--savedynamic(elem,dir3,dir4)
		--rotOfsetElement(elem)
	end
end

local point = {}
local fpoint={}


function positive(dir,r)
	if r >= 0 and r <=90 and dir == "x" then
		return true
	elseif r > 0 and r <=90 and dir == "y" then
		return true
	elseif r > 90 and r <=180 and dir == "x" then
		return false
	elseif r > 90 and r <=180 and dir == "y" then
		return true
	elseif r > 180 and r <=270 and dir == "x" then
		return false
	elseif r > 180 and r <=270 and dir == "y" then
		return false
	elseif r > 270 and r <=361 and dir == "x" then
		return true
	elseif r > 270 and r <=361 and dir == "y" then
		return false
	end
end

function distance(x1,y1,x2,y2) 
	return ((x2-x1)^2+(y2-y1)^2)^0.5
end
local visible = {}
function castRay(pr,rr,id)
		
		local plax,play = pla.act_x,pla.act_y
		local poixx,poiyx,poixy,poiyy 
		local rad_r = math.rad(pr)
		local tan_r = math.tan(rad_r)
		local nothit = true
		local ya = 0
		local xa = 32/tan_r
		local floorplay = math.floor(play/32)
		if not positive("y",pr) then
			poiyy = floorplay*32-0.01
			ya=-32
			xa = 0 - xa
		else
			poiyy = floorplay*32+32
			ya=32
			--xa = 0 - xa
		end
		poixy = plax+(poiyy -play) /tan_r
		local county = 0
		
		while nothit do
			local floorpoiyy,floorpoixy = math.floor(poiyy/32),math.floor(poixy/32)
			if map[floorpoiyy] and map[floorpoiyy][floorpoixy] and map[floorpoiyy][floorpoixy] == 1 then
				nothit = false
			elseif not map[floorpoiyy] or (map[floorpoiyy] and not map[floorpoiyy][floorpoixy]) then
				nothit = false
			elseif county == 15 then
				nothit = false
			else
				poiyy = poiyy + ya
				poixy = poixy + xa
				county = county + 1
				if not visible[(floorpoiyy-1)*#map[1]+floorpoixy] then
					visible[(floorpoiyy-1)*#map[1]+floorpoixy]= id
				end
			end
			
		end
		nothit = true
		xa = 0
		ya = 32*tan_r
		local floorplax= math.floor(plax/32)
		if positive("x",pr) then
			poixx = floorplax*32+32
			xa=32
		else
			poixx = floorplax*32-0.01
			xa=-32
			ya = 0 - ya
		end
		poiyx = play+(poixx -plax)* tan_r
		countx = 0
		
		while nothit do
			local floorpoiyx,floorpoixx = math.floor(poiyx/32),math.floor(poixx/32)
			if map[floorpoiyx] and map[floorpoiyx][floorpoixx] and map[floorpoiyx][floorpoixx] == 1 then
				nothit = false
			elseif not map[floorpoiyx] or (map[floorpoiyx] and not map[floorpoiyx][floorpoixx]) then
				nothit = false
			elseif countx == 15 then
				nothit = false
			else
				poixx = poixx + xa
				poiyx = poiyx + ya
				countx = countx + 1
				if not visible[(floorpoiyx-1)*#map[1]+floorpoixx] then
					visible[(floorpoiyx-1)*#map[1]+floorpoixx]= id
				end
			end
			
		end
		local rad_rr = math.rad(rr)
		local cos_rr = math.cos(rad_rr)
		local d1,d2 = distance(plax,play,poixy,poiyy)* cos_rr,distance(plax,play,poixx,poiyx)* cos_rr
		if d1 < d2 then
			if county == 15 then
				d1 = 0
			else
				d1 = 32/d1*camdist
			end
			
			return poixy/32,poiyy/32,d1,"y",math.floor((math.floor(poixy/32)+1-poixy/32)*64),cos_rr
		else
			if countx == 15 then
				d2 = 0
			else
				d2 = 32/d2*camdist
			end
			return poixx/32,poiyx/32,d2,"x",math.floor((math.floor(poiyx/32)+1-poiyx/32)*64),cos_rr
		end
end

function testBotMap(p,x,y)
	local px,py = (p.grid_x -16)/32,(p.grid_y -16)/32
	if map[py+y][px+x] == 1 then
		return false
	end
	return true
end

function testMonsterMap(bot,dirlst)
	local validdirtab = {}
	local blocked = true
	for i=1,3 do
		local x,y = dirlst[i].x,dirlst[i].y
		if map[(bot.grid_y-16)/32+y][(bot.grid_x-16)/32+x] == 0 and not dynamicmap[((bot.grid_y-16)/32+y-1)*#map[1]+(bot.grid_x-16)/32+x] then 
			blocked = false
			validdirtab[#validdirtab+1] = dirlst[i]
		end
	end
	if blocked then
		if bot.g_r == 0 and dirlst[4].dirid == "l" then
			bot.r = 360
		end
		if bot.g_r == 4 and dirlst[4].dirid == "r" then
			bot.r = 0
		end
		bot.g_r = dirlst[4].dir
		bot.dir = dirlst[4].dirid
	else
		local rand = math.random(1,#validdirtab)
		if bot.g_r == 0 and validdirtab[rand].dirid == "l" then
			bot.r = 360
		end
		if bot.g_r == 4 and validdirtab[rand].dirid == "r" then
			bot.r = 0
		end
		bot.g_r = validdirtab[rand].dir
		bot.dir = validdirtab[rand].dirid
	end
	
end
local botdecisionset = {[0]={{x=0,y=-1,dir=0,dirid="r"},{x=-1,y=0,dir=3,dirid="l"},{x=1,y=0,dir=1,dirid="r"},{x=0,y=1,dir=2,dirid="r"}},[2]={{x=0,y=1,dir=2,dirid="r"},{x=-1,y=0,dir=3,dirid="r"},{x=1,y=0,dir=1,dirid="l"},{x=0,y=-1,dir=0,dirid="l"}},[3]={{x=-1,y=0,dir=3,dirid="r"},{x=0,y=1,dir=2,dirid="l"},{x=0,y=-1,dir=4,dirid="r"},{x=1,y=0,dir=1,dirid="l"}},[1]={{x=1,y=0,dir=1,dirid="r"},{x=0,y=1,dir=2,dirid="r"},{x=0,y=-1,dir=0,dirid="l"},{x=-1,y=0,dir=3,dirid="r"}},[4]={{x=0,y=-1,dir=4,dirid="l"},{x=-1,y=0,dir=3,dirid="l"},{x=1,y=0,dir=1,dirid="r"},{x=0,y=1,dir=2,dirid="l"}}}
function love.update(dt)
	point = {}
	--floorpoint = {}
	if pla.act_y ~= pla.grid_y or pla.act_x ~= pla.grid_x  then
		moveElement(pla,dt)
	end
	if pla.r ~= pla.g_r then
		rotateElement(pla,dt)
	end
	if pla.r == pla.g_r and (not pla.ismoving.overal) then
    		if pla.uu then
			if dirinfo[pla.g_r].is[1] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.dd then
			if dirinfo[pla.g_r].is[2] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0) end
		end
		if pla.sl then
			if dirinfo[pla.g_r].is[4] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.sr then
			if dirinfo[pla.g_r].is[3] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.ll then
			pla.g_r = dirinfo[pla.g_r].l
			pla.dir = "l"
		end
		if pla.rr then
			pla.g_r = dirinfo[pla.g_r].r
			pla.dir = "r"
		end
	end
	visible = {}
	local temppoint = {}
	for i = 1,2*center do
		local pr = pla.r + (i-center)*column
		local pr2 = pr - pla.r
		if pr >= 360 then
			pr = pr - 360
		end
		if pr <= 0 then
			pr = 360 + pr
		end
		if pr2 >= 360 then
			pr2 = pr2 - 360
		end
		if pr2 <= 0 then
			pr2 = 360 + pr2
		end
		local x,y,d,dir,c,cos = castRay(pr,pr2,i)
		point[i]={x=x or 0,y=y or 0,d=d or 0,dir=dir or "y",c=c,id=i,r=pr}
		temppoint[math.floor(pr*5)] = {id=i,cos=cos}
	end
	local langle = point[1],r
	local rangle = point[2*center].r
	for i,bot in pairs(bots) do
	  if bot.alive then
		if not bot.ismoving.overal and bot.r == bot.g_r*90 and bot.act_y == bot.grid_y and bot.act_x == bot.grid_x then
			
			testMonsterMap(bot,botdecisionset[bot.g_r])
			
			if bot.g_r == 0 then moveGrid(bot,"y",-32,0,1)
			elseif bot.g_r == 2 then moveGrid(bot,"y",32,0,-1)
			elseif bot.g_r == 3 then moveGrid(bot,"x",-32,1,0)
			elseif bot.g_r == 1 then moveGrid(bot,"x",32,-1,0) 
			elseif bot.g_r == 4 then moveGrid(bot,"y",-32,0,1) end
			--bot.speed = flormomsters[1][bot.subtype][2]
			dynamicmap[bot.dynamic] = nil
			dynamicmap[((bot.grid_y-16)/32-1)*#map[1]+(bot.grid_x-16)/32] = bot
			bot.dynamic = ((bot.grid_y-16)/32-1)*#map[1]+(bot.grid_x-16)/32
			
			
			
		end
		local xinc = bot.act_y-pla.act_y
		local yinc = bot.act_x-pla.act_x
		local radang = math.floor(math.deg(math.atan2(xinc,yinc))*5)
		if radang < 0 then
			radang = radang + 360*5
		end
		local imgangle = pla.r-bot.r-45
		if imgangle < -360 then
			imgangle = imgangle + 2*360
		elseif imgangle < 0 then
			imgangle = imgangle + 360
		end
		local imgid = math.floor((imgangle)/90)
		if temppoint[radang] then
			point[#point+1] = {x=0 or 0,y=0 or 0,d=32/(distance(pla.act_y,pla.act_x,bot.act_y,bot.act_x)*temppoint[radang].cos)*camdist or 0,dir="f",c=0,id=temppoint[radang].id,img=ratimgT[imgid] or ratimgT[0],bot=bot}
		end
		if (bot.act_y ~= bot.grid_y or bot.act_x ~= bot.grid_x) then
			if bot.r == bot.g_r*90 then
				moveElement(bot,dt)
			else
				rotateElement(bot,dt)
			end
		end
		--[[if (bot.act_y ~= bot.grid_y or bot.act_x ~= bot.grid_x) and bot.r == bot.g_r*90 then
			moveElement(bot,dt)
		
		end
		if bot.r ~= bot.g_r*90 and (bot.act_y ~= bot.grid_y or bot.act_x ~= bot.grid_x) then
			rotateElement(bot,dt)
		end]]
	  end
		    
	end	
	table.sort(point,function(a,b) return a.d<b.d end)

	local fx, fy, fa, fox, foy = fullfloortodraw:getWidth()/2 , fullfloortodraw:getHeight(), math.rad(-pla.r-90), (pla.act_x-32), (pla.act_y-32)
	fullfloortodraw:clear()
	
	fullfloortodraw:renderTo(function()
			love.graphics.setColor(255,255,255)
			love.graphics.draw(fullfloor,fx,fy,fa,1,1,fox,foy)
	end)
	local j = 1
	fpoint = {}
	local tempfloorpoint = {}
	local scxcount = 1
	local d = math.max(point[1].d,32/479*camdist)
	while 200 + d + 1*j < 400 do
		local sc = camdist*16/(d+1*j)
		local sc2 = math.floor(sc*2)
		
		if sc2 > range2-1 then sc2 = range2-1 end
		if sc2 < 0 then sc2 = 0 end
		--local sc2 = sc/math.cos(math.rad(pr2))--(i-center)*column)
		--local olddist = distance(pla.act_x,pla.act_y,x*32,y*32)
		--local newx = x*32-(olddist-sc2)*math.cos(math.rad(pr))
		--local newy = y*32-(olddist-sc2)*math.sin(math.rad(pr))
		--local d2 = math.floor((math.floor(newy/32)+1-newy/32)*32)
		--local d3 = math.floor((math.floor(newx/32)+1-newx/32)*32)
		scxcount = scxcount + 1
		if not tempfloorpoint[sc2] then
			fpoint[#fpoint+1]={i=sc2,sc=32/sc*camdist,y=200 + d + 1*j,scx=scxcount}
			scxcount = 1
		end
		tempfloorpoint[sc2] = true
		j=j+1
	end
	--[[for i=1,#floorent do
		local ent = floorent[i]
		local xinc = ent.act_y-pla.act_y
		local yinc = ent.act_x-pla.act_x
		local radang = math.floor(math.deg(math.atan2(xinc,yinc))*5)
		if radang < 0 then
			radang = radang + 360*5
		end
		local imgangle = pla.r-ent.r-45
		if imgangle < -360 then
			imgangle = imgangle + 2*360
		elseif imgangle < 0 then
			imgangle = imgangle + 360
		end
		local imgid = math.floor((imgangle)/90)
		if temppoint[radang] then
			floorpoint[#floorpoint+1] = {x=0 or 0,y=0 or 0,d=32/((distance(pla.act_y,pla.act_x,ent.act_y,ent.act_x)+16)*temppoint[radang].cos)*camdist or 0,dir="f",c=0,id=temppoint[radang].id,img=f01img,ent=ent}
		end
	end]]
	--table.sort(floorpoint,function(a,b) return a.d<b.d end)
end

function love.draw()
	love.graphics.setColor(255,255,255)
	for i=1, #fpoint do
		love.graphics.setColor(math.min(math.floor(fpoint[i].sc/2),255),math.min(math.floor(fpoint[i].sc/2),255),math.min(math.floor(fpoint[i].sc/2),255))
		love.graphics.drawq(fullfloortodraw, fullfloortodrawQuad[fpoint[i].i], whd-fpoint[i].sc*11.03, fpoint[i].y, 0,fpoint[i].sc/range2*19.93 ,fpoint[i].scx , 0, 0, 0, 0 )
		love.graphics.drawq(fullfloortodraw, fullfloortodrawQuad[fpoint[i].i], whd-fpoint[i].sc*11.03, 400-fpoint[i].y, 0,fpoint[i].sc/range2*19.93 ,fpoint[i].scx , 0, 0, 0, 0 )
		--love.graphics.rectangle("fill",whd,fpoint[i].y,20,1)
	end
	--love.graphics.draw(floordraw,0,0,0,2,2)
	
	--love.graphics.setColor(0,255,255)
	--love.graphics.rectangle("fill",whd,0,whd,centerh)
	--love.graphics.setColor(100,50,50)
	--love.graphics.rectangle("fill",whd,centerh,whd,centerh)
	
	--[[for y=1,#map do
		for x=1,#map[1] do
			if visible[(y-1)*#map[1]+x] then
				love.graphics.rectangle("fill",32+x*2,32+y*2,2,2)
			end
		end
	end]]
	--[[for i=1,#floorpoint do
		local x = floorpoint[i].id*2 
		local y2 = centerh*2 - floorpoint[i].d
		love.graphics.draw(floorpoint[i].img, x-floorpoint[i].d, y2, 0, floorpoint[i].d/32, floorpoint[i].d/32, 0, 0, 0, 0)
	end]]
	for i = 1,#point do
		--love.graphics.setColor(255,255,255)
		
		love.graphics.setColor(math.min(math.floor(point[i].d),255),math.min(math.floor(point[i].d),255),math.min(math.floor(point[i].d),255))
		
		local x = point[i].id*2 
		local y1 = centerh + point[i].d/2
		local y2 = centerh*2 - point[i].d
		--love.graphics.line(x,y1,x,y2)
		if point[i].dir == "f" then
			love.graphics.draw(point[i].img, x-point[i].d, y2, 0, point[i].d/32, point[i].d/32, 0, 0, 0, 0)
			love.graphics.print(math.floor(point[i].bot.r).."   "..point[i].bot.g_r*90,x,y2+point[i].d)
		else
			love.graphics.drawq( wallimg, slicewallimg[64-point[i].c] or slicewallimg[1], x, y2, 0, 2, point[i].d/32, 0, 0, 0, 0 )
		end
	end
	love.graphics.setColor(0,0,0)
	--love.graphics.rectangle("fill",0,0,whd/2,centerh)
	love.graphics.setColor(255,255,255)
	love.graphics.setColor(255,0,0)
	love.graphics.print(math.floor(pla.r).."  "..love.timer.getFPS().."   "..#fpoint,1,1)
	love.graphics.draw(mapdraw,0,0)
	love.graphics.circle("fill",32+pla.act_x/4,32+pla.act_y/4,3)
	love.graphics.setColor(0,0,255)
	for i,bot in pairs(bots) do
		love.graphics.circle("fill",32+bot.act_x/4,32+bot.act_y/4,3)
	end
	--love.graphics.rectangle("fill",math.floor(point.x)*32,math.floor(point.y)*32,32,32)
end

function love.keypressed(key)
	if key == "left" then
    		pla.ll = true
	elseif key == "right" then
    		pla.rr = true
	elseif key == "up" then
    		pla.uu = true
	elseif key == "down" then
    		pla.dd = true
	elseif key == "a" then
    		pla.ll = true
	elseif key == "d" then
    		pla.rr = true
	elseif key == "w" then
    		pla.uu = true
	elseif key == "s" then
    		pla.dd = true
	elseif key == "q" then
    		pla.sl = true
	elseif key == "e" then
    		pla.sr = true	
	end
end

function love.keyreleased(key)
	if key == "left" then
    		pla.ll = false
	elseif key == "right" then
    		pla.rr = false
	elseif key == "up" then
    		pla.uu = false
	elseif key == "down" then
    		pla.dd = false
	elseif key == "a" then
    		pla.ll = false
	elseif key == "d" then
    		pla.rr = false
	elseif key == "w" then
    		pla.uu = false
	elseif key == "s" then
    		pla.dd = false
	elseif key == "q" then
    		pla.sl = false
	elseif key == "e" then
    		pla.sr = false	
	end
end
